#!/usr/bin/ruby

require 'fourteeninch'


case ARGV[0]
when '-v', '--version', 'version'
  puts Fourteeninch::VERSION
when '-h', '--help', 'help'
  puts Fourteeninch::Screens.uses
when 'login'
  Fourteeninch::Auth.auth(true)
when 'logout'
  Fourteeninch::Auth.logout
when 'core'
  Fourteeninch::Core.core
else
  puts "`#{ARGV[0]}` command not found.\n" if ARGV[0]
  puts Fourteeninch::Screens.uses
end